#ifndef IRRLICHTBASE_H
#define IRRLICHTBASE_H

#include <windows.h>
#include "tp_stub.h"
#include <irrlicht.h>


/**
 * Irrlicht ̃x[X
 */
class IrrlichtBase : public irr::IEventReceiver, public tTVPContinuousEventCallbackIntf
{
public:
	enum EventMask {
		EMASK_ATTACH       = 1<<0, //< A^b`
		EMASK_DETACH       = 1<<1, //< f^b`
		EMASK_EVENT        = 1<<2, //< IrrlichtCxg
		EMASK_BEFORE_SCENE = 1<<3, //< V[}l[W`O
		EMASK_AFTER_SCENE  = 1<<4, //< V[}l[W`
		EMASK_BEFORE_GUI   = 1<<5, //< GUI`O
		EMASK_AFTER_GUI    = 1<<6, //< GUI`
	};
	
protected:
	/// TJSIuWFNg
	iTJSDispatch2 *objthis;
	/// foCX
	irr::IrrlichtDevice *device;

	void showDriverInfo();

protected:
	// Cxg}XN
	int eventMask;
	
	/**
	 * TJSCxgĂяoBȃIuWFNg̊Y\bhĂяoB
	 * @param eventName Cxg
	 */
	void sendTJSEvent(const tjs_char *eventName);

protected:
	// foCX蓖čς
	bool attached;

	/**
	 * foCX̊蓖
	 * @param hwnd eEChEnh
	 * @param width obNobt@TCY
	 * @param height obNobt@TCYc
	 */
	void attach(HWND hwnd, int width=0, int height=0);

	// foCX̊蓖Č㏈
	virtual void onAttach() {}
	
	/**
	 * foCX̔j
	 */
	void detach();

	// foCX̔jO
	virtual void onDetach() {};
	
public:
	IrrlichtBase(iTJSDispatch2 *objthis); //!< RXgN^
	virtual ~IrrlichtBase(); //!< fXgN^

	// ------------------------------------------------------------
	// XV
	// ------------------------------------------------------------
protected:
	/**
	 * NXŗLXV
	 * V[}l[W̏AGUȈOɌĂ΂
	 */
	virtual void update(irr::video::IVideoDriver *driver) {};

protected:

	/**
	 * Irrlicht`揈
	 * @param destRect `̈Bȗƕ\S
	 * @param srcRect `挳̈BȗƑS
	 * @param destDC `DCBw肷Ɩ{̕\̑ɂDCɕ`
	 * @return `悳ꂽ true
	 */
	bool show(irr::core::rect<irr::s32> *destRect=NULL, irr::core::rect<irr::s32> *srcRect=NULL, HDC destDC=0);

	// ------------------------------------------------------------
	// Irrlicht ʃvpeB
	// ------------------------------------------------------------
public:

	void setEventMask(int mask) {
		eventMask = mask;
	}

	int getEventMask() {
		return eventMask;
	}

	/**
	 * @return hCo̎擾
	 */
	irr::video::IVideoDriver *getVideoDriver() {
		return device ? device->getVideoDriver() : NULL;
	}
	
	/**
	 * @return V[}l[W̎擾
	 */
	irr::scene::ISceneManager *getSceneManager() {
		return device ? device->getSceneManager() : NULL;
	}

	/**
	 * @return GUI̎擾
	 */
	irr::gui::IGUIEnvironment *getGUIEnvironment() {
		return device ? device->getGUIEnvironment() : NULL;
	}

	/**
	 * @return K[̎擾
	 */
	irr::ILogger *getLogger() {
		return device ? device->getLogger() : NULL;
	}

	/**
	 * @return t@CVXe̎擾
	 */
	irr::io::IFileSystem *getFileSystem() {
		return device ? device->getFileSystem() : NULL;
	}
	
	// ------------------------------------------------------------
	// Irrlicht Cxgp
	// ------------------------------------------------------------
public:
	// Irrlicht ɃCxg𑗂
	bool postEvent(irr::SEvent &ev);

	/**
	 * Cxg
	 * GUI Environment ̃CxgɑĂ
	 * @param event Cxg
	 * @return  true
	 */
	bool OnEvent(const irr::SEvent &event);

	// -----------------------------------------------------------------------
	// continuous handler
	// -----------------------------------------------------------------------
public:
	/**
	 * Irrlicht ĂяoJn
	 */
	void start();

	/**
	 * Irrlicht Ăяof
	 */
	void stop();
};

#endif